/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
var feedback = {
		content: document.getElementById('content'), 
		imageList: document.getElementById('image-list'),
		submitBtn: document.getElementById('submit')
	};
	
(function() {
	var index = 1;
	var size = null;
	var imageIndexIdNum = 0;
	var starIndex = 0;
	
	feedback.files = [];
	feedback.uploader = null;  
	feedback.deviceInfo = null; 
	mui.plusReady(function() {
		//设备信息，无需修改
		feedback.deviceInfo = {
			appid: plus.runtime.appid, 
			imei: plus.device.imei, //设备标识
			images: feedback.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: plus.runtime.version,
			plus_version: plus.runtime.innerVersion, //基座版本号
			os:  mui.os.version,
			net: ''+plus.networkinfo.getCurrentType()
		}
	});
	/**
	 *提交成功之后，恢复表单项 
	 */
	feedback.clearForm = function() {
		feedback.value = '';
		feedback.content.value = '';
		feedback.imageList.innerHTML = '';
		feedback.newPlaceholder();
		feedback.files = [];
		index = 0;
		size = 0;
		imageIndexIdNum = 0;
		starIndex = 0;
		//清除所有星标
		mui('.icons i').each(function (index,element) {
			if (element.classList.contains('mui-icon-star-filled')) {
				element.classList.add('mui-icon-star')
	  			element.classList.remove('mui-icon-star-filled')
			}
		})
	};
	feedback.getFileInputArray = function() {
		return [].slice.call(feedback.imageList.querySelectorAll('.file'));
	};
	feedback.addFile = function(path) {
		feedback.files.push({name:"images"+index,path:path,id:"img-"+index});
		index++;
	};
	
	/**
	 * 初始化图片域占位
	 */
	feedback.newPlaceholder = function() {
		var fileInputArray = feedback.getFileInputArray();
		if(fileInputArray.length>=9) {
			return;
		}
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var up = document.createElement("div");
		up.setAttribute('class','image-up')
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.id = "img-"+index;
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				for(var temp=0;temp<feedback.files.length;temp++){
					if(feedback.files[temp].id==closeButton.id){
						feedback.files.splice(temp,1);
					}
				}
				feedback.imageList.removeChild(placeholder);
				feedback.newPlaceholder();
			}, 0);
			return false;
		}, false);
		
	
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			selectImage();
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		feedback.imageList.appendChild(placeholder);
	};
	feedback.addFileAndZip = function(path) {	
				var placeholderList=mui(".image-item");
				var placeholder=placeholderList[placeholderList.length-1];
				var upList=mui(".image-up");
				var up=upList[upList.length-1];
			
				if(isVideo(path)) {
						plus.io.resolveLocalFileSystemURL(path, function(entry){
								size += entry.size  ;
							if (size > APP_UPLOAD_MAX_SIZE) {
								return mui.toast('文件超大,请重新选择~');
							}
//							if (!placeholder.classList.contains('space')) { //已有图片
//								feedback.files.splice(index-1,1,{name:"images"+index,path:path});
//							} else { //加号
								placeholder.classList.remove('space');
								feedback.addFile(path);
								feedback.newPlaceholder();
//							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(../images/video_blank.jpg)';
						}, function(e){
							mui.toast('读取文件错误：'+e.message);
						});
						
				} else {
					var name = path.substr(path.lastIndexOf('/') + 1);	
					plus.zip.compressImage({
						src: path,
						dst: '_doc/' + name,
						overwrite: true,
						quality: 50
					}, function(zip) {
						size += zip.size  
						if (size > APP_UPLOAD_MAX_SIZE ) {
							return mui.toast('文件超大,请重新选择~');
						}
//						if (!placeholder.classList.contains('space')) { //已有图片  //不起作用
//							console.log(1);
//							feedback.files.splice(index-1,1,{name:"images"+index,path:path});
//						} else { //加号
//							console.log(2);
							placeholder.classList.remove('space');
							feedback.addFile(zip.target);
							feedback.newPlaceholder();
//						}
						up.classList.remove('image-up');
						placeholder.style.backgroundImage = 'url(' + zip.target + ')';
					}, function(zipe) {
						console.log('压缩失败！')
						
						plus.io.resolveLocalFileSystemURL(path, function(entry){
								size += entry.size  ;
							if (size > APP_UPLOAD_MAX_SIZE) {
								return mui.toast('文件超大,请重新选择~');
							}
							if (!placeholder.classList.contains('space')) { //已有图片
								feedback.files.splice(index-1,1,{name:"images"+index,path:path});
							} else { //加号
								placeholder.classList.remove('space');
								feedback.addFile(path);
								feedback.newPlaceholder();
							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(../images/video_blank.jpg)';
						}, function(e){
							mui.toast('读取文件错误：'+e.message);
						});
						
					});
				}
				
				
		};
	feedback.newPlaceholder();
	feedback.submitBtn.addEventListener('tap', function(event) {
		var user=GET_LOGIN_USER();
		
		if( user.blackDate && user.blackDate>new Date().getTime() ) {
			var date=new Date();
			date.setTime(user.blackDate);
			var s=(date.getMonth()+1)+'月'+date.getDate()+'日'+date.getHours()+'点';
			mui.alert('您被关小黑屋了,截止'+s);
			return;
		}

		if(order!=null) {//支付
			floatWebview(order);
			return;
		}
		if (!forum_id ) {
			return mui.alert('请选择圈子');
		}
			
		if( user.forum3 && user.forum3.forum_id==forum_id) {
		} else {
			if( user.userLevel<1 ) {
				mui.alert('请先成为会员');
				return;
			}
		}
	
		feedback.content= document.getElementById('content');
		if (feedback.content.value == '' ) {
			feedback.content.focus();
			return mui.alert('请填写发贴内容');
		}
		if (feedback.content.value.length > 3000 ) {
			return mui.alert('发贴内容不能大于3000个字符')
		}
		//判断网络连接
		if(mui.os.plus && plus.networkinfo.getCurrentType()==plus.networkinfo.CONNECTION_NONE){
			return mui.toast("连接网络失败，请稍后再试");
		}
		var data={
			content: feedback.content.value,
			images: feedback.files,
			forumId:forum_id+'',
			token:GET_LOGIN_USER().token,
			templateId:templateId+''
		};
		for(var i=0;i<vm.labelList.length;i++) {
			var item=vm.labelList[i];
			var key='template_'+item.id;
			var e=document.getElementById(key);
			if(e) {
				var value=e.value;
				data[key]=value;
			}
		}
		//console.log(JSON.stringify(data));
		feedback.send(mui.extend({}, feedback.deviceInfo, data)) 
	}, false)
	feedback.send = function(content) {
		feedback.uploader = plus.uploader.createUpload(APP_URL_BBSTOPIC_ADD, {
			method: 'POST'
		}, function(upload, status) {
			plus.nativeUI.closeWaiting();
//			console.log("upload cb:"+upload.responseText);
			if(status==200){
				var data = JSON.parse(upload.responseText);
				//上传成功，重置表单
				if (data.success) {
					//mui.toast('提交成功,支付后生效')
					if(data.order) {
						order=data.order;
						floatWebview(data);
					} else {
						//mui.back();
						open_detail(data.topic);
					}
				} else {
					mui.alert(data.msg);
				}
			}else{
				mui.alert('提交失败:'+status)
			}
			
		});
		//添加上传数据
		mui.each(content, function(index, element) {
			if (index !== 'images') {
				//console.log("addData:"+index+","+element);
				feedback.uploader.addData(index, element)
			} 
		});
		//添加上传文件
		mui.each(feedback.files, function(index, element) {
			var f = feedback.files[index];
			console.log("addFile:"+JSON.stringify(f));
			feedback.uploader.addFile(f.path, {
				key: f.name
			});
		});
		//开始上传任务
		feedback.uploader.start();
	//	mui.toast('正在提交请稍候......');
//		mui.alert("提交成功，点击确定关闭","问题反馈","确定",function () {
//			feedback.clearForm();
//			mui.back();
//		});
		plus.nativeUI.showWaiting();
	};
	
	
	
})();
