(function($, doc) {
				var MIN_SOUND_TIME = 800;
				$.init({
					gestureConfig: {
						tap: true, //默认为true
						doubletap: true, //默认为false
						longtap: true, //默认为false
						swipe: true, //默认为true
						drag: true, //默认为true
						hold: true, //默认为false，不监听
						release: true //默认为false，不监听
					}
				});
				//template.config('escape', false);
				//$.plusReady=function(fn){fn();};
				$.plusReady(function() {
					plus.webview.currentWebview().setStyle({
						softinputMode: "adjustResize"
					}); 
					var showKeyboard = function() {
						if ($.os.ios) {
							var webView = plus.webview.currentWebview().nativeInstanceObject();
							webView.plusCallMethod({
								"setKeyboardDisplayRequiresUserAction": false
							});
						} else {
							var Context = plus.android.importClass("android.content.Context");
							var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
							var main = plus.android.runtimeMainActivity();
							var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
							imm.showSoftInput(main.getWindow().getDecorView(), InputMethodManager.SHOW_IMPLICIT);
						}
					};
					ui = {
						body: doc.querySelector('body'),
						footer: doc.querySelector('footer'),
						footerRight: doc.querySelector('.footer-right'),
						footerLeft: doc.querySelector('.footer-left'),
						btnMsgType: doc.querySelector('#msg-type'),
						boxMsgText: doc.querySelector('#msg-text'),
						boxMsgSound: doc.querySelector('#msg-sound'),
						btnMsgImage: doc.querySelector('#msg-image'),
					//	areaMsgList: doc.querySelector('#msg-list'),
						boxSoundAlert: doc.querySelector('#sound-alert'),
						h: doc.querySelector('#h'),
						content: doc.querySelector('.mui-content')
					};
					ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
					//alert(ui.boxMsgText.offsetWidth );
					var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;

					
					window.addEventListener('resize', function() {
						//ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
					}, false);
					
					function msgTextFocus() {
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
					}
				//解决长按“发送”按钮，导致键盘关闭的问题；
					ui.footerRight.addEventListener('touchstart', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					//解决长按“发送”按钮，导致键盘关闭的问题；
					ui.footerRight.addEventListener('touchmove', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('touchcancel', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('touchend', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('release', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							//showKeyboard();
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
							//							event.detail.gesture.preventDefault();
							send({
								sender: 'self',
								content_type: 0,
								content: ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>')
							});
							ui.boxMsgText.value = '';
							$.trigger(ui.boxMsgText, 'input', null);
						} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
							ui.btnMsgType.classList.add('mui-icon-compose');
							ui.btnMsgType.classList.remove('mui-icon-mic');
							ui.boxMsgText.style.display = 'none';
							ui.boxMsgSound.style.display = 'block';
							//ui.boxMsgText.blur();
							//document.body.focus();
						} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
							ui.btnMsgType.classList.add('mui-icon-mic');
							ui.btnMsgType.classList.remove('mui-icon-compose');
							ui.boxMsgSound.style.display = 'none';
							ui.boxMsgText.style.display = 'block';
							//--
							//showKeyboard();
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
						}
					}, false);
					ui.footerLeft.addEventListener('tap', function(event) {
						var btnArray = [{
							title: "拍照"
						}, {
							title: "从相册选择"
						},{
							title: "录像"
						},{
							title: "发红包"
						} ];
						plus.nativeUI.actionSheet({
							//title: "选择照片",
							cancel: "取消",
							buttons: btnArray
						}, function(e) {
							var index = e.index;
							switch (index) {
								case 0:
									break;
								case 1:
									var cmr = plus.camera.getCamera();
									cmr.captureImage(function(path) {
										send({
											sender: 'self',
											content_type: 1,
											file: "file://" + plus.io.convertLocalFileSystemURL(path)
										});
									}, function(err) {});
									break;
								case 2:
									plus.gallery.pick(function(path) {
										send({
											sender: 'self',
											content_type: 1,
											file: path
										});
									}, function(err) {}, {filter:'none'});
									break;
								case 3:
									var cmr = plus.camera.getCamera();
									cmr.startVideoCapture(function(path){	
										plus.io.resolveLocalFileSystemURL(path, function(entry){
											var size = entry.size;
											if (size > APP_UPLOAD_MAX_SIZE) {
												return mui.toast('文件超大,请重新选择~');
											}
											send({
												sender: 'self',
												content_type: 3,
												file: path
											});	
										}, function(e){
											mui.toast('读取文件错误：'+e.message);
										});
													
									}, function(e){
										}, {filename:'_doc/camera/'});
									break;
								case 4://红包
									open_redpkg();
									break;
									}
						
						});
					}, false); 
					var setSoundAlertVisable=function(show){
						if(show){
							ui.boxSoundAlert.style.display = 'block';
							ui.boxSoundAlert.style.opacity = 1;
						}else{
							ui.boxSoundAlert.style.opacity = 0;
							//fadeOut 完成再真正隐藏
							setTimeout(function(){
								ui.boxSoundAlert.style.display = 'none';
							},200);
						}
					};
					var recordCancel = false;
					var recorder = null;
					var audio_tips = document.getElementById("audio_tips");
					var startTimestamp = null;
					var stopTimestamp = null;
					var stopTimer = null;
					ui.boxMsgSound.addEventListener('hold', function(event) {
						recordCancel = false;
						if(stopTimer)clearTimeout(stopTimer);
						audio_tips.innerHTML = "手指上划，取消发送";
						ui.boxSoundAlert.classList.remove('rprogress-sigh');
						setSoundAlertVisable(true);
						recorder = plus.audio.getRecorder();
						if (recorder == null) {
							plus.nativeUI.toast("不能获取录音对象");
							return;
						}
						startTimestamp = (new Date()).getTime();
						recorder.record({
							filename: "_doc/audio/"
						}, function(path) {
							if (recordCancel) return;
							send({
								sender: 'self',
								content_type: 2,
								file: path
							});
						}, function(e) {
							plus.nativeUI.toast("录音时出现异常: " + e.message);
						});
					}, false);
					ui.body.addEventListener('drag', function(event) {
						//console.log('drag');
						if (Math.abs(event.detail.deltaY) > 50) {
							if (!recordCancel) {
								recordCancel = true;
								if (!audio_tips.classList.contains("cancel")) {
									audio_tips.classList.add("cancel");
								}
								audio_tips.innerHTML = "松开手指，取消发送";
							}
						} else {
							if (recordCancel) {
								recordCancel = false;
								if (audio_tips.classList.contains("cancel")) {
									audio_tips.classList.remove("cancel");
								}
								audio_tips.innerHTML = "手指上划，取消发送";
							}
						}
					}, false);
					ui.boxMsgSound.addEventListener('release', function(event) {
						//console.log('release');
						if (audio_tips.classList.contains("cancel")) {
							audio_tips.classList.remove("cancel");
							audio_tips.innerHTML = "手指上划，取消发送";
						}
						//
						stopTimestamp = (new Date()).getTime();
						if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
							audio_tips.innerHTML = "录音时间太短";
							ui.boxSoundAlert.classList.add('rprogress-sigh');
							recordCancel = true;
							stopTimer=setTimeout(function(){
								setSoundAlertVisable(false);
							},800);
						}else{
							setSoundAlertVisable(false);
						}
						recorder.stop();
					}, false);
					ui.boxMsgSound.addEventListener("touchstart", function(e) {
						//console.log("start....");
						e.preventDefault();
					});
					ui.boxMsgText.addEventListener('input', function(event) {
						ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
						ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
						ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
						ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
						ui.content.style.paddingBottom = ui.footer.style.height;
					});
					var focus = false;
					ui.boxMsgText.addEventListener('tap', function(event) {
						ui.boxMsgText.focus();
						setTimeout(function() {
							ui.boxMsgText.focus();
						}, 0);
						focus = true;
						setTimeout(function () {
							focus = false;
						},1000);
						event.detail.gesture.preventDefault();
					}, false);
					//点击消息列表，关闭键盘
//					ui.areaMsgList.addEventListener('click',function (event) {
//						if(!focus){
//							ui.boxMsgText.blur();
//						}
//					});
					
					//bindMsgList();
					//msgTextFocus();
				});
			}(mui, document));
			
mui.init({
	swipeBack: false,
	pullRefresh: {
		container: '#pullrefresh',
		down: {
			contentrefresh: '下拉加载...',
			callback: pulldownRefresh,
			auto:false
		}
	}
});


var self=GET_LOGIN_USER().username,forumName='';
var maxId=0,forumId=0; 

//监听自定义事件，获取新闻详情
document.addEventListener('setData', function(event) {
	var item  = event.detail.item;
	if(!item) return;
	forumId=item.id;
	forumName=item.name;
	document.getElementById('forumTitle').innerHTML=forumName;
	vm.List.splice(0);
	self=GET_LOGIN_USER().username;
    minId=0;
	setList();
//	var inputtext=document.getElementById('msg-text');
//	inputtext.value='11';//没用
//	setTimeout(function() {
//		inputtext.focus();
//		inputtext.value='222';//没用
//	}, 5000);

});

bindMsgList = function() {
		//ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
};
					
var vm=new Vue({
				  el: '#pullrefresh',
				  data: {
				  	List:[],
				  	APP_NEWSIMG_HOST:APP_NEWSIMG_HOST
				  },methods: {
					resetData: function() {//重置数据
						this.$data.List.splice(0);
					},
					formatDate:function(t) {
						return DateUtils.format(t); 
					},getPic:function(pic) {
						if(pic) {
							return APP_NEWSIMG_HOST+'/'+pic;
						} else {
							return '../static/images/photo/default.jpg';
						}
					},showName:function(name) {
						return name.replace(' ','&nbsp;&nbsp;&nbsp;&nbsp;');
					}
				}
});


if(!mui.os.plus) {
	var parmlist=window.location.href.split('?');
	forumId=parmlist[1];
	var bbsForumList=JSON.parse(window.sessionStorage.getItem('bbsForumList'));
	if(bbsForumList) {
		for(var i = 0; i < bbsForumList.length; i++) {
			var forum=bbsForumList[i];
				for(var i = 0; i < bbsForumList.length; i++) {
					var forum=bbsForumList[i];
					if(forum.id==forumId) {
						forumName=forum.name;
					}
				}
		}
	} 
	document.getElementById('forumTitle').innerHTML=forumName;
	vm.List.splice(0);
	self=GET_LOGIN_USER().username;
    minId=0;
	setList();
//	var inputtext=document.getElementById('msg-text');
//	inputtext.value='11';//没用
//	setTimeout(function() {
//		inputtext.focus();
//	}, 5000);
}




Vue.nextTick(function () {

}) 
   
function setList() { 	 
		 mui.getJSON(APP_URL_BBSTOPIC_LISTBYCITY+'/'+forumId,{'minId':minId,latlng:GET_GEOLOCATION().latlng,token:GET_LOGIN_USER().token},function(result){
			if(result.success) {
				
				console.log(minId);
					for(var i = result.data.list.length-1; i>=0; i--) {
						vm.List.push(result.data.list[i]); 
					} 
				
					minId= result.minId;
					//console.log(minId);
					mui.previewImage();
//					if(mui.os.plus) {
//						bindMsgList();
//					}
//					setTimeout(function() {
//					//	msg_end.scrollIntoView();
//					}, 5000);	
					//mui.scrollTo(2000,1000); 
//					
//					var inputtext=document.getElementById('msg-text');
//					inputtext.value='33';//没用
//					inputtext.scrollIntoView();
//					setTimeout(function() {
//						inputtext.focus();
//						inputtext.value='444';//没用
//					}, 5000);
				
			}else{
				mui.alert('获取数据失败:'+result.msg);
			}
		});
};

function send(msg) {	
		var task = plus.uploader.createUpload( APP_URL_BBSTOPIC_ADD2, 
		{ method:"POST",blocksize:204800,priority:100 },
		function ( t, status ) {
			//console.log(status);
			var result=JSON.parse(t.responseText);
			// 上传完成
			if ( status == 200  ) {
				if(result.success) {
					mui.toast( "提交成功" );
					minId=result.topic.id;
					self=result.topic.reg_username;
					vm.List.push(result.topic);
					mui.previewImage();
					bindMsgList();
				} else {
					mui.alert(result.msg);
				}
			} else {
				mui.toast('提交失败'+status);
			}
		}
		);
		task.addFile(msg.file, {key:"file"} );
		task.addData( 'token', GET_LOGIN_USER().token );
		task.addData( 'forumId', forumId+"" );
		task.addData('content', msg.content);
		task.addData('content_type', msg.content_type+"");
	
		task.addEventListener( "statechanged", onStateChanged, false );
		task.start();
}

// 监听上传任务状态
		function onStateChanged( upload, status ) {
			//console.log(status+','+upload.state);
			if ( upload.state == 4 && status == 200 ) {
				//console.log(upload.responseText);
			}
		}


function play(url) {
	var w=plus.webview.create('camera_video.html','camera_video.html',{hardwareAccelerated:true,scrollIndicator:'none',scalable:true,bounce:'all'});
	w.addEventListener('loaded', function(){
		w.evalJS('loadMedia("'+url+'")');
	}, false );
	w.addEventListener('close', function(){
		w = null;
	}, false);
	w.show('pop-in');
}

function playSound(url) {
	var p = plus.audio.createPlayer(url);	
	p.play(function(){
				p.stop();
				p=null;
		}, function(e){
			console.log('播放音频文件"'+url+'"失败：'+e.message);
		});
}


window.addEventListener('resize', function() {
	//areaMsgList.scrollTop = areaMsgList.scrollHeight + areaMsgList.offsetHeight;
}, false);
					

/**
 * 下拉刷新具体业务实现
 */
var minId=0;
function pulldownRefresh() {
	mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); 
	mui('#pullrefresh').pullRefresh().refresh(true);
	setList();
}

//监听自定义事件，获取新闻详情
document.addEventListener('add', function(event) {
	var topic=event.detail.topic;
	minId=topic.id;
	vm.List.push(topic);
	mui.previewImage();
	bindMsgList();
});


function open_redpkg() {
		//触发子窗口变更新闻详情
		var webview_detail = mui.preload({
					url: 'redpkg.html',
					id: 'quanzi/redpkg.html'
				});
		mui.fire(webview_detail, 'setData', {
			'forumId':forumId 
		});
		setTimeout(function () {
			if(mui.os.plus) {
				webview_detail.show("slide-in-right", 300);
			} else {
				//window.localStorage.setItem("Id",item.id);
				mui.openWindow('redpkg.html?'+forumId);	
			}
		},150);
};

function redpkg(item) {
	if(item.red_rec_num>=item.red_total_num) {
		mui.alert('手慢元,红包已经被领取完了');
	} else {
		 mui.getJSON(APP_URL_BBSTOPIC_REKPKG+'/'+item.id,{token:GET_LOGIN_USER().token},function(result){
			if(result.success) {
				mui.alert('红包领取成功');
			}else{
				mui.alert(result.msg);
			}
		});
	}
}
