(function($, doc) {
				var MIN_SOUND_TIME = 800;
				$.init({
					gestureConfig: {
						tap: true, //默认为true
						doubletap: true, //默认为false
						longtap: true, //默认为false
						swipe: true, //默认为true
						drag: true, //默认为true
						hold: true, //默认为false，不监听
						release: true //默认为false，不监听
					}
				});
				//template.config('escape', false);
				//$.plusReady=function(fn){fn();};
				$.plusReady(function() {
					plus.webview.currentWebview().setStyle({
						softinputMode: "adjustResize"
					}); 
					var showKeyboard = function() {
						if ($.os.ios) {
							var webView = plus.webview.currentWebview().nativeInstanceObject();
							webView.plusCallMethod({
								"setKeyboardDisplayRequiresUserAction": false
							});
						} else {
							var Context = plus.android.importClass("android.content.Context");
							var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
							var main = plus.android.runtimeMainActivity();
							var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
							imm.showSoftInput(main.getWindow().getDecorView(), InputMethodManager.SHOW_IMPLICIT);
						}
					};
					ui = {
						body: doc.querySelector('body'),
						//footer: doc.querySelector('footer'),
						footerRight: doc.querySelector('.footer-right'),
						footerLeft: doc.querySelector('.footer-left'),
						btnMsgType: doc.querySelector('#msg-type'),
						boxMsgText: doc.querySelector('#msg-text'),
						boxMsgSound: doc.querySelector('#msg-sound'),
						btnMsgImage: doc.querySelector('#msg-image'),
					//	areaMsgList: doc.querySelector('#msg-list'),
						boxSoundAlert: doc.querySelector('#sound-alert'),
						//h: doc.querySelector('#h'),
						//content: doc.querySelector('.mui-content')
					};
					//ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
					//alert(ui.boxMsgText.offsetWidth );
					//var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;

					
					window.addEventListener('resize', function() {
						//ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
					}, false);
					
					function msgTextFocus() {
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
					}
				//解决长按“发送”按钮，导致键盘关闭的问题；
					ui.footerRight.addEventListener('touchstart', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					//解决长按“发送”按钮，导致键盘关闭的问题；
					ui.footerRight.addEventListener('touchmove', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('touchcancel', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('touchend', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							msgTextFocus();
							event.preventDefault();
						}
					});
					ui.footerRight.addEventListener('release', function(event) {
						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
							//showKeyboard();
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
							//							event.detail.gesture.preventDefault();
							send({
								sender: 'self',
								content_type: 0,
								content: ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>')
							});
							ui.boxMsgText.value = '';
							$.trigger(ui.boxMsgText, 'input', null);
						} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
							ui.btnMsgType.classList.add('mui-icon-compose');
							ui.btnMsgType.classList.remove('mui-icon-mic');
							ui.boxMsgText.style.display = 'none';
							ui.boxMsgSound.style.display = 'block';
							//ui.boxMsgText.blur();
							//document.body.focus();
						} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
							ui.btnMsgType.classList.add('mui-icon-mic');
							ui.btnMsgType.classList.remove('mui-icon-compose');
							ui.boxMsgSound.style.display = 'none';
							ui.boxMsgText.style.display = 'block';
							//--
							//showKeyboard();
							ui.boxMsgText.focus();
							setTimeout(function() {
								ui.boxMsgText.focus();
							}, 150);
						}
					}, false);
					ui.footerLeft.addEventListener('tap', function(event) {
						var btnArray = [{
							title: "拍照"
						}, {
							title: "从相册选择"
						},{
							title: "录像"
						},{
							title: "发红包"
						} ];
						plus.nativeUI.actionSheet({
							//title: "选择照片",
							cancel: "取消",
							buttons: btnArray
						}, function(e) {
							var index = e.index;
							switch (index) {
								case 0:
									break;
								case 1:
									var cmr = plus.camera.getCamera();
									cmr.captureImage(function(path) {
										send({
											sender: 'self',
											content_type: 1,
											file: "file://" + plus.io.convertLocalFileSystemURL(path)
										});
									}, function(err) {});
									break;
								case 2:
									plus.gallery.pick(function(path) {
										send({
											sender: 'self',
											content_type: 1,
											file: path
										});
									}, function(err) {}, {filter:'none'});
									break;
								case 3:
									var cmr = plus.camera.getCamera();
									cmr.startVideoCapture(function(path){	
										plus.io.resolveLocalFileSystemURL(path, function(entry){
											var size = entry.size;
											if (size > APP_UPLOAD_MAX_SIZE) {
												return mui.toast('文件超大,请重新选择~');
											}
											send({
												sender: 'self',
												content_type: 3,
												file: path
											});	
										}, function(e){
											mui.toast('读取文件错误：'+e.message);
										});
													
									}, function(e){
										}, {filename:'_doc/camera/'});
									break;
								case 4://红包
									open_redpkg();
									break;
									}
						
						});
					}, false); 
					var setSoundAlertVisable=function(show){
						if(show){
							ui.boxSoundAlert.style.display = 'block';
							ui.boxSoundAlert.style.opacity = 1;
						}else{
							ui.boxSoundAlert.style.opacity = 0;
							//fadeOut 完成再真正隐藏
							setTimeout(function(){
								ui.boxSoundAlert.style.display = 'none';
							},200);
						}
					};
					var recordCancel = false;
					var recorder = null;
				//	var audio_tips = document.getElementById("audio_tips");
					var startTimestamp = null;
					var stopTimestamp = null;
					var stopTimer = null;
					ui.boxMsgSound.addEventListener('hold', function(event) {
						recordCancel = false;
						if(stopTimer)clearTimeout(stopTimer);
						audio_tips.innerHTML = "手指上划，取消发送";
						ui.boxSoundAlert.classList.remove('rprogress-sigh');
						setSoundAlertVisable(true);
//							contentWebview.evalJS('audio_tips.innerHTML = "手指上划，取消发送";');
//							contentWebview.evalJS('ui.boxSoundAlert.classList.remove("rprogress-sigh");');
//							contentWebview.evalJS('setSoundAlertVisable(true);');
							//var sub_webview = plus.webview.getWebviewById('quanzi/dq_sub.html');
//							if(sub_webview) {
								// mui.fire(sub_webview,'audioHold',{});
//							}
				
						recorder = plus.audio.getRecorder();
						if (recorder == null) {
							plus.nativeUI.toast("不能获取录音对象");
							return;
						}
						startTimestamp = (new Date()).getTime();
						recorder.record({
							filename: "_doc/audio/"
						}, function(path) {
							if (recordCancel) return;
							send({
								sender: 'self',
								content_type: 2,
								file: path
							});
						}, function(e) {
							plus.nativeUI.toast("录音时出现异常: " + e.message);
						});
					}, false);
					ui.body.addEventListener('drag', function(event) {
						//console.log('drag');
						if (Math.abs(event.detail.deltaY) > 50) {
							if (!recordCancel) {
								recordCancel = true;
								if (!audio_tips.classList.contains("cancel")) {
									audio_tips.classList.add("cancel");
								}
								audio_tips.innerHTML = "松开手指，取消发送";
//								contentWebview.evalJS('if (!audio_tips.classList.contains("cancel"))audio_tips.classList.add("cancel");');
//								contentWebview.evalJS('audio_tips.innerHTML = "松开手指，取消发送";');
//								var sub_webview = plus.webview.getWebviewById('quanzi/dq_sub.html');
////								if(sub_webview) {
//									 mui.fire(sub_webview,'audioDrag1',{});
////								}
							}
						} else {
							if (recordCancel) {
								recordCancel = false;
								if (audio_tips.classList.contains("cancel")) {
									audio_tips.classList.remove("cancel");
								}
								audio_tips.innerHTML = "手指上划，取消发送";
//								var sub_webview = plus.webview.getWebviewById('quanzi/dq_sub.html');
////								if(sub_webview) {
//									 mui.fire(sub_webview,'audioDrag2',{});
////								}
//								contentWebview.evalJS('audio_tips.innerHTML = "手指上划，取消发送";');
//								contentWebview.evalJS('if (audio_tips.classList.contains("cancel"))audio_tips.classList.remove("cancel");');

							}
						}
					}, false);
					ui.boxMsgSound.addEventListener('release', function(event) {
						//console.log('release');
//						if (audio_tips.classList.contains("cancel")) {
//							audio_tips.classList.remove("cancel");
//							audio_tips.innerHTML = "手指上划，取消发送";
//						}
					//	contentWebview.evalJS('if (audio_tips.classList.contains("cancel")) {audio_tips.classList.remove("cancel");audio_tips.innerHTML = "手指上划，取消发送";}');
						var sub_webview = plus.webview.getWebviewById('quanzi/dq_sub.html');
						mui.fire(sub_webview,'audioRelease1',{});
						stopTimestamp = (new Date()).getTime();
						if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
							recordCancel = true;
							audio_tips.innerHTML = "录音时间太短";
							ui.boxSoundAlert.classList.add('rprogress-sigh');
							stopTimer=setTimeout(function(){
								setSoundAlertVisable(false);
							},800);
//							contentWebview.evalJS('audio_tips.innerHTML = "录音时间太短";');
//							contentWebview.evalJS('boxSoundAlert.classList.add("rprogress-sigh");');
//							contentWebview.evalJS('setSoundAlertVisable(false);');
							//mui.fire(sub_webview,'audioRelease2',{});
						}else{
							setSoundAlertVisable(false);
							//mui.fire(sub_webview,'audioRelease3',{});
							//contentWebview.evalJS('setSoundAlertVisable(false);');
						}
						recorder.stop();
					}, false);
					ui.boxMsgSound.addEventListener("touchstart", function(e) {
						//console.log("start....");
						e.preventDefault();
					});
					ui.boxMsgText.addEventListener('input', function(event) {
						ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
						ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
						//ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
						//ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
						//ui.content.style.paddingBottom = ui.footer.style.height;
					});
					//var focus = false;
					ui.boxMsgText.addEventListener('tap', function(event) {
						ui.boxMsgText.focus();
						setTimeout(function() {
							ui.boxMsgText.focus();
						}, 1000);
//						focus = true;
//						setTimeout(function () {
//							focus = false;
//						},1000);
						//event.detail.gesture.preventDefault();
					}, false);
				});
			}(mui, document));
			


bindMsgList = function() {
		//ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
};
	


function send(msg) {	
	//selectUser();
	
	var user=GET_LOGIN_USER();
	if(IS_LOGIN() && user.blackDate && user.blackDate>new Date().getTime() ) {
		var date=new Date().setTime(user.blackDate);
		var s=(date.getMonth()+1)+'月'+date.getDate()+'日'+date.getHours()+'点';
		mui.alert('您被关小黑屋期间不能发言,截止'+s);
		return;
	} 
	
	
							
							
		var task = plus.uploader.createUpload( APP_URL_BBSTOPIC_ADD2, 
		{ method:"POST",blocksize:204800,priority:100 },
		function ( t, status ) {
			plus.nativeUI.closeWaiting();
			//console.log(status);
			var result=JSON.parse(t.responseText);
			// 上传完成
			if ( status == 200  ) {
				if(result.success) {
					//mui.toast( "提交成功" );
					
					mui.fire(webview_sub, 'add', {'topic':result.topic});
				} else {
					mui.alert(result.msg);
				}
			} else {
				mui.toast('提交失败'+status);
			}
		}
		);
		task.addFile(msg.file, {key:"file"} );
		task.addData( 'token', GET_LOGIN_USER().token );
		task.addData( 'forumId', forumId+"" );
		task.addData('content', msg.content);
		task.addData('content_type', msg.content_type+"");
		
		var userIds=new Array();
		for(var j=0;j<vm.list.length;j++) {
			if(msg.content.indexOf('@'+vm.list[j].name)!=-1 || vm.list[j].id=='all') {
				userIds.push(vm.list[j].id);
			}
		}
		task.addData('userIds', userIds.join(','));
		task.addEventListener( "statechanged", onStateChanged, false );
		task.start();
		vm.list.splice(0);
		plus.nativeUI.showWaiting();
}

// 监听上传任务状态
		function onStateChanged( upload, status ) {
			//console.log(status+','+upload.state);
			if ( upload.state == 4 && status == 200 ) {
				//console.log(upload.responseText);
			}
		}



/**
 * 下拉刷新具体业务实现
 */
var minId=0;

//监听自定义事件，获取新闻详情
document.addEventListener('add', function(event) {
	var topic=event.detail.topic;
	minId=topic.id;
	vm.List.push(topic);
	mui.previewImage();
	bindMsgList();
});


function open_redpkg() {
		//触发子窗口变更新闻详情
		var webview_detail = mui.preload({
					url: '../payment/payment_feered.html',
					id: 'payment/payment_feered.html'
				});
		mui.fire(webview_detail, 'setData', {
			'forumId':forumId 
		});
		setTimeout(function () {
			if(mui.os.plus) {
				webview_detail.show("slide-in-right", 300);
			} else {
				//window.localStorage.setItem("Id",item.id);
				mui.openWindow('redpkg.html?'+forumId);	
			}
		},150);
};
